from flask import Blueprint, request, redirect
from flask_login import login_user, UserMixin, login_required, logout_user
from . import db
import random
import string

auth = Blueprint('auth', __name__)

ACCESS_TOKEN = ''.join(random.choice(string.ascii_lowercase) for i in range(64))

ERROR_TEXT =  """
              For security-reasons we must make sure you are the person who executed jon :D <br />
              <form action="" method="get">
                  <input type="password" name="token" placeholder="Token" />
                  <input type="hidden" hidden name="next" value="{next}" />
                  <input type="submit" value="login" />
              </form>
              <hr />

              """

class User(UserMixin):
    id: int = 0

@auth.route('/login')
def login():
    token = request.args.get('token')
    next: str = request.args.get('next') or "/"
    if token is None:
        # TODO: make template
        return ERROR_TEXT.format(next=next) + "No token provided!"
    if token == ACCESS_TOKEN:
        login_user(User(), remember=True)
        return redirect(next)
    else:
        return ERROR_TEXT.format(next=next) + "Invalid token!"

@auth.route('/logout')
def logout():
    logout_user()
    return redirect("/")
